// Generated by psc version 0.8.0.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Tuple = require("../Data.Tuple");
var Data_Maybe = require("../Data.Maybe");
var Data_Function = require("../Data.Function");
var Data_StrMap = require("../Data.StrMap");
var verbJsonType = function (def) {
    return function (f) {
        return function (fold) {
            return fold(def)(f);
        };
    };
};

/**
 *  Decoding
 */
var toJsonType = verbJsonType(Data_Maybe.Nothing.value)(Data_Maybe.Just.create);
var showJson = new Prelude.Show($foreign._stringify);
var showJNull = new Prelude.Show(function (v) {
    return "null";
});
var jsonZero = $foreign.fromNumber(0.0);
var jsonTrue = $foreign.fromBoolean(true);
var jsonSingletonObject = function (key) {
    return function (val) {
        return $foreign.fromObject(Data_StrMap.singleton(key)(val));
    };
};
var jsonSingletonArray = function (j) {
    return $foreign.fromArray([ j ]);
};
var jsonFalse = $foreign.fromBoolean(false);
var jsonEmptyString = $foreign.fromString("");
var jsonEmptyObject = $foreign.fromObject(Data_StrMap.empty);
var jsonEmptyArray = $foreign.fromArray([  ]);

/**
 *  Tests
 */
var isJsonType = verbJsonType(false)(Prelude["const"](true));
var foldJsonString = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), f, Prelude["const"](d), Prelude["const"](d), j);
        };
    };
};
var isString = isJsonType(foldJsonString);
var toString = toJsonType(foldJsonString);
var foldJsonObject = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), f, j);
        };
    };
};
var isObject = isJsonType(foldJsonObject);
var toObject = toJsonType(foldJsonObject);
var foldJsonNumber = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(Prelude["const"](d), Prelude["const"](d), f, Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), j);
        };
    };
};
var isNumber = isJsonType(foldJsonNumber);
var toNumber = toJsonType(foldJsonNumber);
var foldJsonNull = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(f, Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), j);
        };
    };
};
var isNull = isJsonType(foldJsonNull);
var toNull = toJsonType(foldJsonNull);
var foldJsonBoolean = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(Prelude["const"](d), f, Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), j);
        };
    };
};
var isBoolean = isJsonType(foldJsonBoolean);
var toBoolean = toJsonType(foldJsonBoolean);
var foldJsonArray = function (d) {
    return function (f) {
        return function (j) {
            return $foreign._foldJson(Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), Prelude["const"](d), f, Prelude["const"](d), j);
        };
    };
};
var isArray = isJsonType(foldJsonArray);
var toArray = toJsonType(foldJsonArray);
var foldJson = function (a) {
    return function (b) {
        return function (c) {
            return function (d) {
                return function (e) {
                    return function (f) {
                        return function (json) {
                            return $foreign._foldJson(a, b, c, d, e, f, json);
                        };
                    };
                };
            };
        };
    };
};
var ordJson = new Prelude.Ord(function () {
    return eqJson;
}, function (a) {
    return function (b) {
        return $foreign._compare(Prelude.EQ.value, Prelude.GT.value, Prelude.LT.value, a, b);
    };
});
var eqJson = new Prelude.Eq(function (j1) {
    return function (j2) {
        return Prelude["=="](Prelude.eqOrdering)(Prelude.compare(ordJson)(j1)(j2))(Prelude.EQ.value);
    };
});

/**
 *  Instances
 */
var eqJNull = new Prelude.Eq(function (v) {
    return function (v1) {
        return true;
    };
});
var ordJNull = new Prelude.Ord(function () {
    return eqJNull;
}, function (v) {
    return function (v1) {
        return Prelude.EQ.value;
    };
});
module.exports = {
    jsonSingletonObject: jsonSingletonObject, 
    jsonEmptyObject: jsonEmptyObject, 
    jsonSingletonArray: jsonSingletonArray, 
    jsonEmptyArray: jsonEmptyArray, 
    jsonZero: jsonZero, 
    jsonTrue: jsonTrue, 
    jsonFalse: jsonFalse, 
    toObject: toObject, 
    toArray: toArray, 
    toString: toString, 
    toNumber: toNumber, 
    toBoolean: toBoolean, 
    toNull: toNull, 
    isObject: isObject, 
    isArray: isArray, 
    isString: isString, 
    isNumber: isNumber, 
    isBoolean: isBoolean, 
    isNull: isNull, 
    foldJsonObject: foldJsonObject, 
    foldJsonArray: foldJsonArray, 
    foldJsonString: foldJsonString, 
    foldJsonNumber: foldJsonNumber, 
    foldJsonBoolean: foldJsonBoolean, 
    foldJsonNull: foldJsonNull, 
    foldJson: foldJson, 
    eqJNull: eqJNull, 
    ordJNull: ordJNull, 
    showJNull: showJNull, 
    eqJson: eqJson, 
    ordJson: ordJson, 
    showJson: showJson, 
    jsonNull: $foreign.jsonNull, 
    fromObject: $foreign.fromObject, 
    fromArray: $foreign.fromArray, 
    fromString: $foreign.fromString, 
    fromNumber: $foreign.fromNumber, 
    fromBoolean: $foreign.fromBoolean, 
    fromNull: $foreign.fromNull
};
