// Generated by psc version 0.8.0.0
"use strict";
var $foreign = require("./foreign");
var Prelude = require("../Prelude");
var Data_Argonaut_Printer = require("../Data.Argonaut.Printer");
var Data_Argonaut_Parser = require("../Data.Argonaut.Parser");
var Data_Argonaut_Decode = require("../Data.Argonaut.Decode");
var Data_Argonaut_Encode = require("../Data.Argonaut.Encode");
var Data_Array = require("../Data.Array");
var Data_Array_Unsafe = require("../Data.Array.Unsafe");
var Data_Either = require("../Data.Either");
var Data_Foldable = require("../Data.Foldable");
var Data_Traversable = require("../Data.Traversable");
var Data_StrMap = require("../Data.StrMap");
var Data_StrMap_ST = require("../Data.StrMap.ST");
var Data_Maybe = require("../Data.Maybe");
var Data_Set = require("../Data.Set");
var Data_String = require("../Data.String");
var Control_Monad_Eff = require("../Control.Monad.Eff");
var Control_Monad_Eff_Console = require("../Control.Monad.Eff.Console");
var Control_Monad_Eff_Exception = require("../Control.Monad.Eff.Exception");
var Control_Monad_ST = require("../Control.Monad.ST");
var Control_Apply = require("../Control.Apply");
var Control_Monad = require("../Control.Monad");
var Node_Process = require("../Node.Process");
var Node_ChildProcess = require("../Node.ChildProcess");
var Node_Stream = require("../Node.Stream");
var Node_Buffer = require("../Node.Buffer");
var Node_Encoding = require("../Node.Encoding");
var Node_FS = require("../Node.FS");
var Node_FS_Sync = require("../Node.FS.Sync");
var Psa = require("../Psa");
var Psa_Printer_Default = require("../Psa.Printer.Default");
var Psa_Types = require("../Psa.Types");
var Psa_Output = require("../Psa.Output");
var Data_Posix_Signal = require("../Data.Posix.Signal");
var usage = "psa - Error/Warning reporting frontend for psc \n\nUsage: psa [--censor-lib] [--censor-src]\n           [--censor-codes=CODES] [--filter-codes=CODES]\n           [--no-colors] [--no-source]\n           [--is-lib=DIR] [--psc=PSC] [--stash]\n           PSC_OPTIONS\n\nAvailable options:\n  -v,--version           Show the version number\n  -h,--help              Show this help text\n  --verbose-stats        Show counts for each warning type\n  --censor-warnings      Censor all warnings\n  --censor-lib           Censor warnings from library sources\n  --censor-src           Censor warnings from project sources\n  --censor-codes=CODES   Censor specific error codes\n  --filter-codes=CODES   Only show specific error codes\n  --no-colors            Disable ANSI colors\n  --no-source            Disable original source code printing\n  --strict               Promotes src warnings to errors\n  --stash                Enable persistent warnings (defaults to .psa-stash)\n  --stash=FILE           Enable persistent warnings using a specific stash file\n  --is-lib=DIR           Distinguishing key for lib sources (defaults to 'bower_components')\n  --psc=PSC              Name of psc executable (defaults to 'psc')\n\n  CODES                  Comma-separated list of psc error codes\n  PSC_OPTIONS            Any extra options are passed to psc\n";
var parseOptions = function (opts) {
    var isPrefix = function (s) {
        return function (str) {
            var $21 = Data_String.indexOf(s)(str);
            if ($21 instanceof Data_Maybe.Just && $21.value0 === 0) {
                return true;
            };
            return false;
        };
    };
    var parse = function (p) {
        return function (arg) {
            if (Prelude["=="](Prelude.eqString)(arg)("--version") || Prelude["=="](Prelude.eqString)(arg)("-v")) {
                return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log($foreign.version))(Node_Process.exit(0));
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--help") || Prelude["=="](Prelude.eqString)(arg)("-h")) {
                return Control_Apply["*>"](Control_Monad_Eff.applyEff)(Control_Monad_Eff_Console.log(usage))(Node_Process.exit(0));
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--stash")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $25 = {};
                    for (var $26 in p) {
                        if (p.hasOwnProperty($26)) {
                            $25[$26] = p[$26];
                        };
                    };
                    $25.stash = true;
                    return $25;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--no-source")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $27 = {};
                    for (var $28 in p) {
                        if (p.hasOwnProperty($28)) {
                            $27[$28] = p[$28];
                        };
                    };
                    $27.showSource = false;
                    return $27;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--no-colors")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $31 = {};
                    for (var $32 in p) {
                        if (p.hasOwnProperty($32)) {
                            $31[$32] = p[$32];
                        };
                    };
                    $31.opts = (function () {
                        var $29 = {};
                        for (var $30 in p.opts) {
                            if (p.opts.hasOwnProperty($30)) {
                                $29[$30] = p.opts[$30];
                            };
                        };
                        $29.ansi = false;
                        return $29;
                    })();
                    return $31;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--verbose-stats")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $35 = {};
                    for (var $36 in p) {
                        if (p.hasOwnProperty($36)) {
                            $35[$36] = p[$36];
                        };
                    };
                    $35.opts = (function () {
                        var $33 = {};
                        for (var $34 in p.opts) {
                            if (p.opts.hasOwnProperty($34)) {
                                $33[$34] = p.opts[$34];
                            };
                        };
                        $33.verboseStats = true;
                        return $33;
                    })();
                    return $35;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--strict")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $39 = {};
                    for (var $40 in p) {
                        if (p.hasOwnProperty($40)) {
                            $39[$40] = p[$40];
                        };
                    };
                    $39.opts = (function () {
                        var $37 = {};
                        for (var $38 in p.opts) {
                            if (p.opts.hasOwnProperty($38)) {
                                $37[$38] = p.opts[$38];
                            };
                        };
                        $37.strict = true;
                        return $37;
                    })();
                    return $39;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-warnings")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $43 = {};
                    for (var $44 in p) {
                        if (p.hasOwnProperty($44)) {
                            $43[$44] = p[$44];
                        };
                    };
                    $43.opts = (function () {
                        var $41 = {};
                        for (var $42 in p.opts) {
                            if (p.opts.hasOwnProperty($42)) {
                                $41[$42] = p.opts[$42];
                            };
                        };
                        $41.censorWarnings = true;
                        return $41;
                    })();
                    return $43;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $47 = {};
                    for (var $48 in p) {
                        if (p.hasOwnProperty($48)) {
                            $47[$48] = p[$48];
                        };
                    };
                    $47.opts = (function () {
                        var $45 = {};
                        for (var $46 in p.opts) {
                            if (p.opts.hasOwnProperty($46)) {
                                $45[$46] = p.opts[$46];
                            };
                        };
                        $45.censorLib = true;
                        return $45;
                    })();
                    return $47;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-lib")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $51 = {};
                    for (var $52 in p) {
                        if (p.hasOwnProperty($52)) {
                            $51[$52] = p[$52];
                        };
                    };
                    $51.opts = (function () {
                        var $49 = {};
                        for (var $50 in p.opts) {
                            if (p.opts.hasOwnProperty($50)) {
                                $49[$50] = p.opts[$50];
                            };
                        };
                        $49.censorLib = true;
                        return $49;
                    })();
                    return $51;
                })());
            };
            if (Prelude["=="](Prelude.eqString)(arg)("--censor-src")) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $55 = {};
                    for (var $56 in p) {
                        if (p.hasOwnProperty($56)) {
                            $55[$56] = p[$56];
                        };
                    };
                    $55.opts = (function () {
                        var $53 = {};
                        for (var $54 in p.opts) {
                            if (p.opts.hasOwnProperty($54)) {
                                $53[$54] = p.opts[$54];
                            };
                        };
                        $53.censorSrc = true;
                        return $53;
                    })();
                    return $55;
                })());
            };
            if (isPrefix("--censor-codes=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $59 = {};
                    for (var $60 in p) {
                        if (p.hasOwnProperty($60)) {
                            $59[$60] = p[$60];
                        };
                    };
                    $59.opts = (function () {
                        var $57 = {};
                        for (var $58 in p.opts) {
                            if (p.opts.hasOwnProperty($58)) {
                                $57[$58] = p.opts[$58];
                            };
                        };
                        $57.censorCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.censorCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                        return $57;
                    })();
                    return $59;
                })());
            };
            if (isPrefix("--filter-codes=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $63 = {};
                    for (var $64 in p) {
                        if (p.hasOwnProperty($64)) {
                            $63[$64] = p[$64];
                        };
                    };
                    $63.opts = (function () {
                        var $61 = {};
                        for (var $62 in p.opts) {
                            if (p.opts.hasOwnProperty($62)) {
                                $61[$62] = p.opts[$62];
                            };
                        };
                        $61.filterCodes = Data_Foldable.foldr(Data_Foldable.foldableArray)(Data_Set.insert(Prelude.ordString))(p.opts.filterCodes)(Data_String.split(",")(Data_String.drop(15)(arg)));
                        return $61;
                    })();
                    return $63;
                })());
            };
            if (isPrefix("--is-lib=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $67 = {};
                    for (var $68 in p) {
                        if (p.hasOwnProperty($68)) {
                            $67[$68] = p[$68];
                        };
                    };
                    $67.opts = (function () {
                        var $65 = {};
                        for (var $66 in p.opts) {
                            if (p.opts.hasOwnProperty($66)) {
                                $65[$66] = p.opts[$66];
                            };
                        };
                        $65.libDir = Data_String.drop(9)(arg);
                        return $65;
                    })();
                    return $67;
                })());
            };
            if (isPrefix("--psc=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $69 = {};
                    for (var $70 in p) {
                        if (p.hasOwnProperty($70)) {
                            $69[$70] = p[$70];
                        };
                    };
                    $69.psc = Data_String.drop(6)(arg);
                    return $69;
                })());
            };
            if (isPrefix("--stash=")(arg)) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $71 = {};
                    for (var $72 in p) {
                        if (p.hasOwnProperty($72)) {
                            $71[$72] = p[$72];
                        };
                    };
                    $71.stash = true;
                    $71.stashFile = Data_String.drop(8)(arg);
                    return $71;
                })());
            };
            if (Prelude.otherwise) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)((function () {
                    var $73 = {};
                    for (var $74 in p) {
                        if (p.hasOwnProperty($74)) {
                            $73[$74] = p[$74];
                        };
                    };
                    $73.extra = Data_Array.snoc(p.extra)(arg);
                    return $73;
                })());
            };
            throw new Error("Failed pattern match at Main line 94, column 1 - line 99, column 1: " + [ p.constructor.name, arg.constructor.name ]);
        };
    };
    return Data_Array.foldM(Control_Monad_Eff.monadEff)(parse)({
        extra: [  ], 
        psc: "psc", 
        showSource: true, 
        stash: false, 
        stashFile: ".psa-stash", 
        opts: opts
    });
};
var defaultOptions = {
    ansi: true, 
    censorWarnings: false, 
    censorLib: false, 
    censorSrc: false, 
    censorCodes: Data_Set.empty, 
    filterCodes: Data_Set.empty, 
    verboseStats: false, 
    libDir: "bower_components", 
    strict: false, 
    cwd: ""
};
var main = (function () {
    
    /**
     *  TODO: Handle exceptions
     */
    var stdio = [ new Data_Maybe.Just(Node_ChildProcess.Pipe.value), Node_ChildProcess.inherit[1], new Data_Maybe.Just(Node_ChildProcess.Pipe.value) ];
    var mergeWarnings = function (filenames) {
        return function (old) {
            return function ($$new) {
                return function __do() {
                    var v = Data_StrMap_ST["new"]();
                    var v1 = Prelude.flip(Data_Array.filterM(Control_Monad_Eff.monadEff))(old)(function (x) {
                        if (x.filename instanceof Data_Maybe.Nothing) {
                            return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                        };
                        if (x.filename instanceof Data_Maybe.Just) {
                            var $77 = Data_Set.member(Prelude.ordString)(x.filename.value0)(filenames);
                            if ($77) {
                                return Prelude.pure(Control_Monad_Eff.applicativeEff)(false);
                            };
                            if (!$77) {
                                return function __do() {
                                    var v1 = Data_StrMap_ST.peek(v)(x.filename.value0)();
                                    return (function () {
                                        if (v1 instanceof Data_Maybe.Just) {
                                            return Prelude.pure(Control_Monad_Eff.applicativeEff)(v1.value0);
                                        };
                                        if (v1 instanceof Data_Maybe.Nothing) {
                                            return function __do() {
                                                var v2 = Node_FS_Sync.exists(x.filename.value0)();
                                                Data_StrMap_ST.poke(v)(x.filename.value0)(v2)();
                                                return v2;
                                            };
                                        };
                                        throw new Error("Failed pattern match: " + [ v1.constructor.name ]);
                                    })()();
                                };
                            };
                            throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ $77.constructor.name ]);
                        };
                        throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ x.filename.constructor.name ]);
                    })();
                    return Prelude["<>"](Prelude.semigroupArray)(v1)($$new);
                };
            };
        };
    };
    var loadNothing = function (v) {
        return function (v1) {
            return Prelude.pure(Control_Monad_Eff.applicativeEff)(Data_Maybe.Nothing.value);
        };
    };
    var loadLines = function (files) {
        return function (filename) {
            return function (pos) {
                return function __do() {
                    var v = (function __do() {
                        var cache = Data_StrMap_ST.peek(files)(filename)();
                        if (cache instanceof Data_Maybe.Just) {
                            return cache.value0;
                        };
                        if (cache instanceof Data_Maybe.Nothing) {
                            var v = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(filename))();
                            Data_StrMap_ST.poke(files)(filename)(v)();
                            return v;
                        };
                        throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ cache.constructor.name ]);
                    })();
                    return (function () {
                        var source = Data_Array.slice(pos.startLine - 1)(pos.endLine)(v);
                        return Prelude.pure(Control_Monad_Eff.applicativeEff)(new Data_Maybe.Just(source));
                    })()();
                };
            };
        };
    };
    var insertFilenames = Data_Foldable.foldr(Data_Foldable.foldableArray)(function (x) {
        return function (s) {
            return Data_Maybe.maybe(s)(Prelude.flip(Data_Set.insert(Prelude.ordString))(s))(x.filename);
        };
    });
    var encodeStash = function (s) {
        return Data_Argonaut_Encode.encodeJson(Data_Argonaut_Encode.encodeJsonArray(Data_Argonaut_Encode.encodeJsonJson))(Prelude["<$>"](Prelude.functorArray)(Psa_Types.encodePsaError)(s));
    };
    var writeStashFile = function (stashFile) {
        return function (warnings) {
            var file = Data_Argonaut_Printer.printJson(Data_Argonaut_Printer.printerString)(encodeStash(warnings));
            return Node_FS_Sync.writeTextFile(Node_Encoding.UTF8.value)(stashFile)(file);
        };
    };
    var decodeStash = function (s) {
        return Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(s))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeArray(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson)))))(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(Psa_Types.parsePsaError));
    };
    var readStashFile = function (stashFile) {
        return function __do() {
            var v = Node_FS_Sync.exists(stashFile)();
            return (function () {
                if (v) {
                    return function __do() {
                        var v1 = Node_FS_Sync.readTextFile(Node_Encoding.UTF8.value)(stashFile)();
                        return decodeStash(v1);
                    };
                };
                if (!v) {
                    return Prelude.pure(Control_Monad_Eff.applicativeEff)(new Data_Either.Left(stashFile + " does not exist"));
                };
                throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ v.constructor.name ]);
            })()();
        };
    };
    return Prelude["void"](Control_Monad_Eff.functorEff)(function __do() {
        var v = Node_Process.cwd();
        var v1 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process.argv)();
        var v2 = parseOptions((function () {
            var $93 = {};
            for (var $94 in defaultOptions) {
                if (defaultOptions.hasOwnProperty($94)) {
                    $93[$94] = defaultOptions[$94];
                };
            };
            $93.cwd = v;
            return $93;
        })())(v1)();
        var v3 = (function () {
            if (v2.stash) {
                return Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Either.either(Prelude["const"]([  ]))(Prelude.id(Prelude.categoryFn)))(readStashFile(v2.stashFile));
            };
            if (!v2.stash) {
                return Prelude.pure(Control_Monad_Eff.applicativeEff)([  ]);
            };
            throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ v2.stash.constructor.name ]);
        })()();
        var v4 = Node_ChildProcess.spawn(v2.psc)(Data_Array.cons("--json-errors")(v2.extra))((function () {
            var $98 = {};
            for (var $99 in Node_ChildProcess.defaultSpawnOptions) {
                if (Node_ChildProcess.defaultSpawnOptions.hasOwnProperty($99)) {
                    $98[$99] = Node_ChildProcess.defaultSpawnOptions[$99];
                };
            };
            $98.stdio = stdio;
            return $98;
        })())();
        var v5 = Control_Monad_ST.newSTRef("")();
        Node_Stream.onDataString(Node_ChildProcess.stderr(v4))(Node_Encoding.UTF8.value)(function (chunk) {
            return Prelude["void"](Control_Monad_Eff.functorEff)(Control_Monad_ST.modifySTRef(v5)(function (v6) {
                return v6 + chunk;
            }));
        })();
        return Node_ChildProcess.onExit(v4)(function (status) {
            if (status instanceof Node_ChildProcess.Normally) {
                return function __do() {
                    var v6 = Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_String.split("\n"))(Control_Monad_ST.readSTRef(v5))();
                    Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(Data_Foldable.foldableArray)(v6)(function (err) {
                        var $104 = Prelude[">>="](Data_Either.bindEither)(Prelude[">>="](Data_Either.bindEither)(Data_Argonaut_Parser.jsonParser(err))(Data_Argonaut_Decode.decodeJson(Data_Argonaut_Decode.decodeStrMap(Data_Argonaut_Decode.decodeJsonJson))))(Psa_Types.parsePsaResult);
                        if ($104 instanceof Data_Either.Left) {
                            return Control_Monad_Eff_Console.error(err);
                        };
                        if ($104 instanceof Data_Either.Right) {
                            return function __do() {
                                var v7 = Data_StrMap_ST["new"]();
                                return (function () {
                                    var loadLinesImpl = (function () {
                                        if (v2.showSource) {
                                            return loadLines(v7);
                                        };
                                        if (!v2.showSource) {
                                            return loadNothing;
                                        };
                                        throw new Error("Failed pattern match at Main line 210, column 19 - line 211, column 15: " + [ v2.showSource.constructor.name ]);
                                    })();
                                    var filenames = insertFilenames(insertFilenames(Data_Set.empty)($104.value0.errors))($104.value0.warnings);
                                    return function __do() {
                                        var v8 = mergeWarnings(filenames)(v3)($104.value0.warnings)();
                                        var v9 = Psa_Output.output(Control_Monad_Eff.monadEff)(loadLinesImpl)(v2.opts)((function () {
                                            var $109 = {};
                                            for (var $110 in $104.value0) {
                                                if ($104.value0.hasOwnProperty($110)) {
                                                    $109[$110] = $104.value0[$110];
                                                };
                                            };
                                            $109.warnings = v8;
                                            return $109;
                                        })())();
                                        Control_Monad.when(Control_Monad_Eff.monadEff)(v2.stash)(writeStashFile(v2.stashFile)(v8))();
                                        Psa_Printer_Default.print(v2.opts)(v9)();
                                        var $112 = Data_StrMap.isEmpty(v9.stats.allErrors);
                                        if ($112) {
                                            return Node_Process.exit(0)();
                                        };
                                        if (!$112) {
                                            return Node_Process.exit(1)();
                                        };
                                        throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ $112.constructor.name ]);
                                    };
                                })()();
                            };
                        };
                        throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ $104.constructor.name ]);
                    })();
                    return Node_Process.exit(status.value0)();
                };
            };
            if (status instanceof Node_ChildProcess.BySignal) {
                return function __do() {
                    Control_Monad_Eff_Console.error(Prelude.show(Data_Posix_Signal.showSignal)(status.value0))();
                    return Node_Process.exit(1)();
                };
            };
            throw new Error("Failed pattern match at Main line 176, column 1 - line 177, column 1: " + [ status.constructor.name ]);
        })();
    });
})();
module.exports = {
    main: main, 
    parseOptions: parseOptions, 
    defaultOptions: defaultOptions, 
    usage: usage, 
    version: $foreign.version
};
